"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = __importDefault(require("typescript"));
var utils_1 = require("./utils");
var LanguageServiceHost = /** @class */ (function () {
    function LanguageServiceHost(options, cwd) {
        this._versions = new Map();
        this._snapshots = new Map();
        this._fileNames = new Set();
        this._compileOptions = options;
        this._cwd = cwd;
        var files = utils_1.getDeclareFile(cwd);
        for (var i = 0; i < files.length; i += 1) {
            this._fileNames.add(files[i]);
        }
    }
    LanguageServiceHost.prototype.getCompilationSettings = function () {
        return this._compileOptions;
    };
    LanguageServiceHost.prototype.getScriptFileNames = function () {
        return __spread(this._fileNames.values());
    };
    LanguageServiceHost.prototype.getScriptVersion = function (fileName) {
        return (this._versions.get(fileName) || 0).toString();
    };
    LanguageServiceHost.prototype.setScriptSnapshot = function (fileName, code) {
        this._fileNames.add(fileName);
        var version = (this._versions.get(fileName) || 0) + 1;
        this._versions.set(fileName, version);
        var snapshot = typescript_1.default.ScriptSnapshot.fromString(code);
        this._snapshots.set(fileName, snapshot);
    };
    LanguageServiceHost.prototype.getScriptSnapshot = function (fileName) {
        if (this._snapshots.has(fileName)) {
            return this._snapshots.get(fileName);
        }
        var code = typescript_1.default.sys.readFile(fileName);
        if (code) {
            this.setScriptSnapshot(fileName, code);
            return this._snapshots.get(fileName);
        }
    };
    LanguageServiceHost.prototype.getCurrentDirectory = function () {
        return this._cwd;
    };
    LanguageServiceHost.prototype.getDefaultLibFileName = function (opts) {
        return typescript_1.default.getDefaultLibFilePath(opts);
    };
    LanguageServiceHost.prototype.fileExists = function (path) {
        return typescript_1.default.sys.fileExists(path);
    };
    LanguageServiceHost.prototype.readFile = function (path, encoding) {
        return typescript_1.default.sys.readFile(path, encoding);
    };
    LanguageServiceHost.prototype.readDirectory = function (path, extensions, exclude, include, depth) {
        return typescript_1.default.sys.readDirectory(path, extensions, exclude, include, depth);
    };
    LanguageServiceHost.prototype.directoryExists = function (dirName) {
        return typescript_1.default.sys.directoryExists(dirName);
    };
    LanguageServiceHost.prototype.getDirectories = function (dirName) {
        return typescript_1.default.sys.getDirectories(dirName);
    };
    return LanguageServiceHost;
}());
exports.default = LanguageServiceHost;
