"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.printDiagnosticError = exports.logError = void 0;
var chalk_1 = __importDefault(require("chalk"));
var typescript_1 = __importDefault(require("typescript"));
function logError() {
    var _a;
    var rest = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        rest[_i] = arguments[_i];
    }
    console.log((_a = chalk_1.default.bold).red.apply(_a, __spread(rest)));
}
exports.logError = logError;
function printDiagnosticError(arr) {
    var isHasError = false;
    for (var i = 0; i < arr.length; i += 1) {
        var diagnostic = arr[i];
        if (diagnostic.category = typescript_1.default.DiagnosticCategory.Error) {
            isHasError = true;
        }
        var message = typescript_1.default.flattenDiagnosticMessageText(diagnostic.messageText, '\n');
        if (diagnostic.file && typeof diagnostic.start === 'number') {
            var _a = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start), line = _a.line, character = _a.character;
            logError(diagnostic.file.fileName + " (" + (line + 1) + "," + (character + 1) + "): error\n TS" + diagnostic.code + ":" + message);
        }
        else {
            logError("Error: " + message);
        }
    }
    return isHasError;
}
exports.printDiagnosticError = printDiagnosticError;
